# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Subscriptions::Mgmt::V2018_11_01_preview
  module Models
    #
    # The parameters required to create a new subscription.
    #
    class ModernSubscriptionCreationParameters

      include MsRestAzure

      # @return [String] The friendly name of the subscription.
      attr_accessor :display_name

      # @return [String] The ARM ID of the billing profile for which you want
      # to create the subscription.
      attr_accessor :billing_profile_id

      # @return [String] The SKU ID of the Azure plan. Azure plan determines
      # the pricing and service-level agreement of the subscription.  Use 001
      # for Microsoft Azure Plan and 002 for Microsoft Azure Plan for DevTest.
      attr_accessor :sku_id

      # @return [String] If set, the cost center will show up on the Azure
      # usage and charges file.
      attr_accessor :cost_center

      # @return [AdPrincipal] If specified, the AD principal will get owner
      # access to the subscription, along with the user who is performing the
      # create subscription operation
      attr_accessor :owner

      # @return [String] The identifier of the management group to which this
      # subscription will be associated.
      attr_accessor :management_group_id

      # @return Additional, untyped parameters to support custom subscription
      # creation scenarios.
      attr_accessor :additional_parameters


      #
      # Mapper for ModernSubscriptionCreationParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ModernSubscriptionCreationParameters',
          type: {
            name: 'Composite',
            class_name: 'ModernSubscriptionCreationParameters',
            model_properties: {
              display_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'displayName',
                type: {
                  name: 'String'
                }
              },
              billing_profile_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'billingProfileId',
                type: {
                  name: 'String'
                }
              },
              sku_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'skuId',
                type: {
                  name: 'String'
                }
              },
              cost_center: {
                client_side_validation: true,
                required: false,
                serialized_name: 'costCenter',
                type: {
                  name: 'String'
                }
              },
              owner: {
                client_side_validation: true,
                required: false,
                serialized_name: 'owner',
                type: {
                  name: 'Composite',
                  class_name: 'AdPrincipal'
                }
              },
              management_group_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'managementGroupId',
                type: {
                  name: 'String'
                }
              },
              additional_parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'additionalParameters',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
