# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Subscriptions::Mgmt::V2019_11_01
  module Models
    #
    # Location information.
    #
    class Location

      include MsRestAzure

      # @return [String] The fully qualified ID of the location. For example,
      # /subscriptions/00000000-0000-0000-0000-000000000000/locations/westus.
      attr_accessor :id

      # @return [String] The subscription ID.
      attr_accessor :subscription_id

      # @return [String] The location name.
      attr_accessor :name

      # @return [String] The display name of the location.
      attr_accessor :display_name

      # @return [String] The display name of the location and its region.
      attr_accessor :regional_display_name

      # @return [LocationMetadata] Metadata of the location, such as lat/long,
      # paired region, and others.
      attr_accessor :metadata


      #
      # Mapper for Location class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Location',
          type: {
            name: 'Composite',
            class_name: 'Location',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              subscription_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'subscriptionId',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'displayName',
                type: {
                  name: 'String'
                }
              },
              regional_display_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'regionalDisplayName',
                type: {
                  name: 'String'
                }
              },
              metadata: {
                client_side_validation: true,
                required: false,
                serialized_name: 'metadata',
                type: {
                  name: 'Composite',
                  class_name: 'LocationMetadata'
                }
              }
            }
          }
        }
      end
    end
  end
end
