# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Subscriptions::Mgmt::V2019_11_01
  module Models
    #
    # Subscription information.
    #
    class Subscription

      include MsRestAzure

      # @return [String] The fully qualified ID for the subscription. For
      # example, /subscriptions/00000000-0000-0000-0000-000000000000.
      attr_accessor :id

      # @return [String] The subscription ID.
      attr_accessor :subscription_id

      # @return [String] The subscription display name.
      attr_accessor :display_name

      # @return [String] The subscription tenant ID.
      attr_accessor :tenant_id

      # @return [SubscriptionState] The subscription state. Possible values are
      # Enabled, Warned, PastDue, Disabled, and Deleted. Possible values
      # include: 'Enabled', 'Warned', 'PastDue', 'Disabled', 'Deleted'
      attr_accessor :state

      # @return [SubscriptionPolicies] The subscription policies.
      attr_accessor :subscription_policies

      # @return [String] The authorization source of the request. Valid values
      # are one or more combinations of Legacy, RoleBased, Bypassed, Direct and
      # Management. For example, 'Legacy, RoleBased'.
      attr_accessor :authorization_source

      # @return [Array<ManagedByTenant>] An array containing the tenants
      # managing the subscription.
      attr_accessor :managed_by_tenants

      # @return [Hash{String => String}] The tags attached to the subscription.
      attr_accessor :tags


      #
      # Mapper for Subscription class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Subscription',
          type: {
            name: 'Composite',
            class_name: 'Subscription',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              subscription_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'subscriptionId',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'displayName',
                type: {
                  name: 'String'
                }
              },
              tenant_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tenantId',
                type: {
                  name: 'String'
                }
              },
              state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'state',
                type: {
                  name: 'Enum',
                  module: 'SubscriptionState'
                }
              },
              subscription_policies: {
                client_side_validation: true,
                required: false,
                serialized_name: 'subscriptionPolicies',
                type: {
                  name: 'Composite',
                  class_name: 'SubscriptionPolicies'
                }
              },
              authorization_source: {
                client_side_validation: true,
                required: false,
                serialized_name: 'authorizationSource',
                type: {
                  name: 'String'
                }
              },
              managed_by_tenants: {
                client_side_validation: true,
                required: false,
                serialized_name: 'managedByTenants',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ManagedByTenantElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ManagedByTenant'
                      }
                  }
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
