# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Subscriptions::Mgmt::V2019_11_01
  module Models
    #
    # Tenant Id information.
    #
    class TenantIdDescription

      include MsRestAzure

      # @return [String] The fully qualified ID of the tenant. For example,
      # /tenants/00000000-0000-0000-0000-000000000000.
      attr_accessor :id

      # @return [String] The tenant ID. For example,
      # 00000000-0000-0000-0000-000000000000.
      attr_accessor :tenant_id

      # @return [TenantCategory] Category of the tenant. Possible values
      # include: 'Home', 'ProjectedBy', 'ManagedBy'
      attr_accessor :tenant_category

      # @return [String] Country/region name of the address for the tenant.
      attr_accessor :country

      # @return [String] Country/region abbreviation for the tenant.
      attr_accessor :country_code

      # @return [String] The display name of the tenant.
      attr_accessor :display_name

      # @return [Array<String>] The list of domains for the tenant.
      attr_accessor :domains


      #
      # Mapper for TenantIdDescription class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'TenantIdDescription',
          type: {
            name: 'Composite',
            class_name: 'TenantIdDescription',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              tenant_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tenantId',
                type: {
                  name: 'String'
                }
              },
              tenant_category: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tenantCategory',
                type: {
                  name: 'Enum',
                  module: 'TenantCategory'
                }
              },
              country: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'country',
                type: {
                  name: 'String'
                }
              },
              country_code: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'countryCode',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'displayName',
                type: {
                  name: 'String'
                }
              },
              domains: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'domains',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
